#include "config.h"

#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "vdef.h"
#include "vrt.h"

int
main(int argc, char **argv) {
	void *dlhdl;
	char buf[256];
	const struct vmod_data *d;
	const char *name = argv[1];
	const char *file = argv[2];


	dlhdl = dlopen(file, RTLD_LAZY | RTLD_LOCAL);
	if (dlhdl == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		return (1);
	}
	bprintf(buf, "Vmod_%s_Data", name);
	d = dlsym(dlhdl, buf);
	if (d == NULL) {
		fprintf(stderr, "dlsym: %s\n", dlerror());
		return (1);
	}

	printf(d->proto);
	printf("\nstatic const struct vmod_data import_%s = {\n", buf);
	printf("\t.name =\t\t\"%s\",\n", d->name);
	printf("\t.file_id =\t\"%s\",\n", d->file_id);
	printf("\t.abi =\t\t\"%s\",\n", d->abi);
	printf("};\n");

	return (0);
}
